#include <bits/stdc++.h>
#define pb push_back
#define ll long long
#define FOR(n) for(int i = 0; i < n; i++)
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long, long long>
#define pdd pair<double, double>
#define mii map<int,int>
#define C const int
using namespace std;
C mxn = 2e5;
int n,c,q;
string s;
char a[mxn];

int money(){
    int m = 0;
    if(c==n){
        FOR(n){
            if(a[i]=='1') m++;
        }
    }
    else if(c==1){
        int i = 0;
        while(i<n){
            if(a[i]=='1'){
                m++;
                while(a[i]=='1')i++;
                i--;
            }
            i++;
        }
    }

    return m;
}

void query(){
    int l,r; cin >> l >> r; l--;r--;
    for(int i = l; i <= r; i++) {
        if(a[i]=='0') a[i]='1';
        else a[i]='0';
    }
    cout << money() << "\n";
}

int main(){
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);

    cin >> n >> c >> q;
    string s; cin >> s;
    FOR(s.size()) a[i] = s[i];
    FOR(q){
        query();
    }


}